list assets.md
List Assets
Media API · Assets
GET https://app.mk.io/api/v1/projects/{project_name}/media/assets
Listing, Sorting and Filtering Assets
This endpoint returns the list of assets in the specified project.
Sorting
The results from this endpoint can be ordered using the $orderby query parameter. Specify a list of field names, separated by commas where each one can optionally specify asc or desc.
Sorting is valid on the following fields: created, createdBy, id, labels, name, properties/alternateId, properties/assetId, properties/container, properties/containerDeletionPolicy, properties/created, properties/lastModified, properties/storageAccountName, properties/subPath, updated, updatedBy
Filtering
There are two ways to filter the set of returned assets from this endpoint - the first is to use the $filter query parameter, the second is to use the $label_key and $label query parameters.
The $filter query parameter allows for assets to be filtered on the basis of fields in the schema using OData query syntax. See this document for more details on the syntax used.
Filters are valid on the following fields: created, createdBy, createdByEmail, createdByName, id, labels, name, properties/alternateId, properties/assetId, properties/container, properties/containerDeletionPolicy, properties/created, properties/lastModified, properties/storageAccountName, properties/subPath, updated, updatedBy, updatedByEmail, updatedByName
$label_key and $label are specific to querying assets based on their labels. Labels are a set of key-value pairs that can be used to identify assets with any arbitrary metadata you want, specifically for the purpose of retrieving relevant subsets of assets.
Examples:
?$top=10 - Returns only the first 10 assets from the list.
?$orderby=name desc - Sorts assets by name in descending order.
?$filter=name eq 'descriptive name' - Returns assets that match the provided name.
?$orderby=created desc - Sorts assets by creation date in descending order.
?$filter=created ge 2021-01-01T00:00:00Z - Returns assets created after January 1, 2021.
?$label=studio=paravalley - Returns assets with the label studio set to paravalley.
?$label=release-date~2023 - Returns assets with the label release-date set to a value that contains 2023.
?$label_key=studio&label_key=release-date - Returns assets with any value set for the studio label and the release-date label.
RBAC Capability Required: ams.asset.get
Authentication
Authorizationheader — Bearer authentication of the formBearer <token>.
Path parameters
| Name | Type | Required | Description |
|---|---|---|---|
project_name |
string | Yes | — |
Query parameters
| Name | Type | Required | Description |
|---|---|---|---|
$orderby |
string | No | Specifies the key by which the result collection should be ordered. |
$filter |
string | No | Restricts the set of items returned. |
$top |
string | No | Specifies a non-negative integer n that limits the number of items returned from a collection. The service returns the number of available items up to but not greater than the specified value n. |
$skiptoken |
string | No | Specifies a start offset to support paginated results. Use @odata.nextLink in the result object to enumerate the collection - it will be present only if there's more than one page of entities. |
$label_key |
string | No | Filters the set to the specified label key. If multiple $label_keys are specified, matching items must have all labels. |
$label |
string | No | Filters the set to the specified label key/value pair. Supports equality, inequality, and inexact matching. If multiple values are provided for the same key, items matching either value will be returned. |
Example request
curl -X GET "https://app.mk.io/api/v1/projects/{project_name}/media/assets" \
-H "Authorization: Bearer <token>"
Responses
200 — A list of assets
@odata.nextLink· string · Optional — @odata.nextLink URL if the page length and number of items match.supplemental· object · Required — Supplemental infocount· integer · Required — Number of items returnedkind· string · Required — Type of items in the listoperation· string · Required — Operation type. Should always say 'list'pagination· object · Required — Pagination infoend· integer · Required — Position of the last item in the listrecords· integer · Required — Total number of items returned in the liststart· integer · Required — Position of the first item in the listtotal· integer · Required — Total number of items in the project
subscription· object · Optional — Project infoid· string · Required — Project IDname· string · Required — Project name
value· list of objects · Required — A list of assets.- Array items (object):
id· string · Optional — Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}labels· map from strings to string · Optional — A dictionary of labels associated with the resource. - Maximum number of labels: 32. - Maximum length of a label or value: 256 characters. - Label: alphanumeric, hyphens and underscores. - Value: alphanumeric, hyphens, underscores and spaces.[any key]· string — map of additional properties
name· string · Optional · 1-260 characters · pattern: ^[^'<>%&:?/*+]+$ — The name of the resourceproperties· object · Required — The properties of the asset.alternateId· string · Optional · 0-64 characters — An alternate ID of the asset.assetId· string · Optional · format: uuid — The Asset ID.container· string · Optional · 3-63 characters · pattern: ^(?!.--)(?=[a-z0-9-]{3,63}$)(?!-)[a-z0-9]+(?:-[a-z0-9]+)$ — The name of the container if this asset is stored in an Azure storage account.containerDeletionPolicy· enum · Optional — This field defines the deletion policy for the underlying storage. This determines the behavior when an asset record is deleted. There are two options, 'Delete', and 'Retain'. A deletion policy of 'Delete' will result in the associated storage container or folder and all its contents being removed. A deletion policy of 'Retain' will leave the content in place. If left blank, the default behavior of the system will be to retain content. Once set by the user, this value can be modified, but not un-set.- Allowed values:
Delete,Retain
- Allowed values:
created· string · Optional · format: date-time — The creation date of the Asset.description· string · Optional · 0-4096 characters — The Asset description.encryptionScope· string or null · Optional — Accepted, not supported. The name of the encryption scope to use within your storage container. Errors may be cryptic.lastModified· string · Optional · format: date-time — The last modified date of the Asset.storageAccountName· string · Required · 0-255 characters — The name of the storage in MK.IO.storageEncryptionFormat· enum · Optional — This field was deprecated in the v3 API. Accepted, not supported. Use an encryption scope instead.- Allowed values:
None,MediaStorageClientEncryption
- Allowed values:
subPath· string · Optional · 1-256 characters · pattern: ^(?!/)(?!.(//|?|%|&)).[^/]$ — Optional subpath for instances where your asset is not in the root of the container. This needs to be an absolute directory path and can't be an empty string or start with '.', './' or '/' or end with '/'. Valid examples: 'path', 'path2', 'path/to/asset'
systemData· object · Optional — Metadata pertaining to creation and last modification of the resource.createdAt· string · Required · format: date-time — The timestamp of resource creation (UTC).createdBy· string · Required — The identity that created the resource.createdByType· enum · Required — The type of identity that created the resource.- Allowed values:
User,Application,ManagedIdentity,Key
- Allowed values:
internalId· string · Required · format: uuid — The internal ID of the resource.lastModifiedAt· string · Required · format: date-time — The timestamp of resource last modification (UTC).lastModifiedBy· string · Required — The identity that last modified the resource.lastModifiedByType· enum · Required — The type of identity that last modified the resource.- Allowed values:
User,Application,ManagedIdentity,Key
- Allowed values:
type· string · Optional — The type of the resource. E.g. "Microsoft.Media/mediaservices/assets"
- Array items (object):
400 — Bad Request
error· object · Required — Pertinent information about the errorcode· string · Required — The error code.detail· string · Required — The error message.extraDetail· map from strings to any · Optional — Extra information regarding this error.[any key]· any — map of additional properties
ref· string · Required — A reference to the request that caused the error.status· integer · Required — The HTTP status code
401 — Unauthorized
403 — Forbidden
404 — Not Found
429 — Too Many Requests
500 — Internal Server Error
Source spec: media-api · operationId: [get]_/api/v1/projects/{project_name}/media/assets